#include <iostream>
#include <map>
using namespace std;

void print_map(const map<string, int>& data) {
    for (const auto& player : data) {
        cout << player.first << ": " << player.second << endl;
    }
}

int main() {
	typedef map<string, int> mapType;
	mapType data;

	data["Bob"] = 10;
	data["Michael"] = 15;
	data["Mark"] = 34;
	data["Rick"] = 22;
	data["Rick"] = 23;	//	overwrites the 22 as keys are unique

//	Iterate over the map and print out all key/value pairs.
    print_map(data);
	cout << endl;

	cout << "map size: " << data.size() << endl;
//	default constructor is used to create the new element
	cout << "array[\"John\"] = " << data["John"] << endl;
	cout << "map size: " << data.size() << endl;

	auto it = data.find("Bob");
	data.erase(it);					// erasing by iterator
	data.erase("John");		// erasing by key
	it = data.find("Rick");
	data.erase(it, data.end() );	// erasing by range

	cout << endl;
    print_map(data);

	return 0;
}

