#include <iostream>
#include <map>
using namespace std;

int main() {
	multimap<int, int> map_1; // empty multimap container

	// insert elements in random order
	map_1.insert(pair<int, int>(1, 40));
	map_1.insert(pair<int, int>(6, 50));
	map_1.insert(pair<int, int>(2, 30));
	map_1.insert(pair<int, int>(3, 60));
	map_1.insert(pair<int, int>(6, 10));

	// printing multimap map_1
	multimap<int, int>::iterator itr;
	cout << "\nThe multimap map_1 is : \n";
	cout << "\tKEY\tELEMENT\n";
	for (itr = map_1.begin(); itr != map_1.end(); ++itr) {
		cout << '\t' << itr->first << '\t' << itr->second << '\n';
	}
	cout << endl;

	// adding elements randomly,
	// to check the sorted keys property
	map_1.insert(pair<int, int>(4, 50));
	map_1.insert(pair<int, int>(5, 10));

	// printing multimap map_1 again
	cout << "\nThe multimap map_1 after adding extra "
			"elements is : \n";
	cout << "\tKEY\tELEMENT\n";
	for (itr = map_1.begin(); itr != map_1.end(); ++itr) {
		cout << '\t' << itr->first << '\t' << itr->second << '\n';
	}
	cout << endl;

	// assigning the elements from map_1 to map_2
	multimap<int, int> map_2(map_1.begin(), map_1.end());

	// print all elements of the multimap map_2
	cout << "\nThe multimap map_2 after assign from map_1 is :\n";
	cout << "\tKEY\tELEMENT\n";
	for (itr = map_2.begin(); itr != map_2.end(); ++itr) {
		cout << '\t' << itr->first << '\t' << itr->second << '\n';
	}
	cout << endl;

	// remove all elements up to
	// key with value 3 in map_2
	cout << "\nmap_2 after removal of elements less than key=3 :\n";
	cout << "\tKEY\tELEMENT\n";
	map_2.erase(map_2.begin(), map_2.find(3));
	for (itr = map_2.begin(); itr != map_2.end(); ++itr) {
		cout << '\t' << itr->first << '\t' << itr->second << '\n';
	}

	// remove all elements with key = 4
	auto num = map_2.erase(4);
	cout << "\nmap_2.erase(4) : ";
	cout << num << " removed \n";
	cout << "\tKEY\tELEMENT\n";
	for (itr = map_2.begin(); itr != map_2.end(); ++itr) {
		cout << '\t' << itr->first << '\t' << itr->second << '\n';
	}
	cout << endl;

	// lower bound and upper bound for multimap map_1 key = 5
	cout << "map_1.lower_bound(5) : " << "\tKEY = ";
	cout << map_1.lower_bound(5)->first << '\t';
	cout << "\tELEMENT = " << map_1.lower_bound(5)->second << endl;
	cout << "map_1.upper_bound(5) : " << "\tKEY = ";
	cout << map_1.upper_bound(5)->first << '\t';
	cout << "\tELEMENT = " << map_1.upper_bound(5)->second << endl;

	return 0;
}

