#include <iostream>
#include <set>
using namespace std;

int main() {
	// empty multiset container
	multiset<int, greater<> > set_1;

	// insert elements in random order
	set_1.insert(40);
	set_1.insert(30);
	set_1.insert(60);
	set_1.insert(20);
	set_1.insert(50);

	// 50 will be added again to
	// the multiset unlike set
	set_1.insert(50);
	set_1.insert(10);

	// printing multiset set_1
	multiset<int, greater<> >::iterator itr;
	cout << "\nThe multiset set_1 is :\n";
	for (itr = set_1.begin(); itr != set_1.end(); ++itr) {
		cout << *itr << " ";
	}
	cout << endl;

	// assigning the elements from set_1 to set_2
	multiset<int> set_2(set_1.begin(), set_1.end());

	// print all elements of the multiset set_2
	cout << "\nThe multiset set_2 \n"
	        "after assign from set_1 is : \n";
	for (itr = set_2.begin(); itr != set_2.end(); ++itr) {
		cout << *itr << " ";
	}
	cout << endl;

	// remove all elements up to element
	// with value 30 in set_2
	cout << "\nset_2 after removal \n"
	        "of elements less than 30 : \n";
	set_2.erase(set_2.begin(), set_2.find(30));
	for (itr = set_2.begin(); itr != set_2.end(); ++itr) {
		cout << *itr << " ";
	}

	// remove all elements with value 50 in set_2
	auto num = set_2.erase(50);
	cout << "\nset_2.erase(50) : \n";
	cout << num << " removed \n";
	for (itr = set_2.begin(); itr != set_2.end(); ++itr) {
		cout << *itr << " ";
	}
	cout << endl;

	// lower bound and upper bound for multiset set_1
	cout << "\nset_1.lower_bound(40) : \n"
	     << *set_1.lower_bound(40) << endl;
	cout << "set_1.upper_bound(40) : \n"
	     << *set_1.upper_bound(40) << endl;

	// lower bound and upper bound for multiset set_2
	cout << "set_2.lower_bound(40) : \n"
	     << *set_2.lower_bound(40) << endl;
	cout << "set_2.upper_bound(40) : \n"
	     << *set_2.upper_bound(40) << endl;

	return 0;
}

