#include <iostream>
#include <queue>
#include <stack>
using namespace std;

//	QUEUE

//	empty() - returns true if queue empty
//	size() - returns number of elements in the queue
//	pop() - removes the first element (but does not return it)
//	front() - returns the first element but does not remove it
//	back() - returns the last element but does not remove it
//	push() - inserts element at the end of the queue

//	PRIORITY QUEUE

//	empty() - returns true if queue empty
//	size() - returns number of elements in the queue
//	pop() - removes the first element (but does not return it)
//	top() - returns the element with highest priority but does not remove it
//	push() - inserts element according to its priority

//	STACK

//	empty() - returns true if stack empty
//	size() - returns number of elements in the stack
//	pop() - removes element from the top (but does not return it)
//	top() - returns the element from the top but does not remove it
//	push() - inserts element at the top of the stack

int main() {
	int tab[] {1, 2, 40, 8, 6};

	queue<int> q;
	for (int n : tab) q.push(n);
	cout << "Queue: ";
	while (!q.empty()) {
		cout << q.front() << " ";
		q.pop();
	}
	cout << endl;

	priority_queue<int> pq_less;
	for (int & n : tab) pq_less.push(n);
	cout << "Priority queue(std::less): ";
	while (!pq_less.empty()) {
		cout << pq_less.top() << " ";
		pq_less.pop();
	}
	cout << endl;

    auto my_comparator = [](int n1, int n2) { return n2 < n1; };
    priority_queue<int, vector<int>, decltype(my_comparator)> pq_greater(my_comparator);
    for (int n : tab) pq_greater.push(n);
    cout << "Priority queue(my_comparator): ";
    while (!pq_greater.empty()) {
        cout << pq_greater.top() << " ";
        pq_greater.pop();
    }
    cout << endl;

	stack<int> s;
	for (int & n : tab) s.push(n);
	cout << "Stack: ";
	while (!s.empty()) {
		cout << s.top() << " ";
		s.pop();
	}
	cout << endl;
	return 0;
}
	
