#include <iostream>
#include <set>
#include <algorithm>
using namespace std;

void print_set(const set<int> &s, const string& prompt) {
	cout << "Set "s + prompt + ": "s;
	for_each(s.begin(), s.end(), [](auto e) { cout << e << " "; });
	cout << endl;
}

int main() {
	
	set A { 1, 5, 3, 9, 3, 8, 3, 0 };
	set B { 4, 7, 2, 8, 0, 0, 4, 0, 2 };
	set<int> C;

	print_set(A, "A");
	print_set(B, "B");

	set_union(A.begin(), A.end(), B.begin(), B.end(),
		  inserter(C, C.begin()));
	print_set(C, "A + B");

	C.clear();
	set_intersection(A.begin(), A.end(), B.begin(), B.end(),
		  inserter(C, C.begin()));
	print_set(C, "A * B");

	C.clear();
	set_difference(A.begin(), A.end(), B.begin(), B.end(),
		  inserter(C, C.begin()));
	print_set(C, "A - B");

	return 0;
}
	
