#include <iostream>
#include <random>
#include <vector>
#include <algorithm>
using namespace std;

struct Description {
	string title{};
	int mark{};
};

bool operator<(const Description&, const Description&);
bool betterThan(const Description&, const Description&);
istream& ReadDesc(Description&);
void PrintDesc(const vector<Description>&);

int main() {
	vector<Description> books;
	Description temp;
	cout << endl;
	while (ReadDesc(temp)) books.push_back(temp);

	cout << endl;
	cout << "Data entered: " << endl;
	PrintDesc(books);

	sort(books.begin(), books.end());	//	use operator<
	cout << "Sorting by title: " << endl;
	PrintDesc(books);

	sort(books.begin(), books.end(), betterThan);	//	use a bool function
	cout << "Sorting by mark: " << endl;
	PrintDesc(books);

	shuffle(books.begin(), books.end(), mt19937(random_device()()));
	cout << "After random shuffling: " << endl;
	PrintDesc(books);
	return 0;
}

bool operator< (const Description &d1, const Description &d2) {
	if (d1.title < d2.title) return true;
	return d1.title == d2.title && d1.mark < d2.mark;
}

bool betterThan (const Description &d1, const Description &d2) {
	return d1.mark > d2.mark;
}
	
istream& ReadDesc (Description &d) {
	return cin >> d.title >> d.mark;
}

void PrintDesc (const vector<Description> &v) {
	cout << "mark\ttitle" << endl;
	for (const auto& book : v)
		cout << book.mark << "\t\t" << book.title << endl;
	cout << endl;
}

